/*
 * QUARTZ DC graphics
 *
 * Copyright 1999 Patrik Stridvall
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "config.h"

#include <stdarg.h>

#include "windef.h"
#include "winbase.h"
#include "winnls.h"
#include "gdi.h"
#include "wine/debug.h"
#include "quartzdrv.h"

WINE_DEFAULT_DEBUG_CHANNEL(quartzdrv);

/***********************************************************************
 *		QUARTZDRV_DC_Arc
 */
BOOL QUARTZDRV_DC_Arc(QUARTZDRV_PDEVICE *physDev, INT left, INT top, INT right, INT bottom,
		   INT xstart, INT ystart, INT xend, INT yend)
{
  FIXME("(%p, %d, %d, %d, %d, %d, %d, %d, %d): stub\n",
        physDev, left, top, right, bottom, xstart, ystart, xend, yend);
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_Chord
 */
BOOL QUARTZDRV_DC_Chord(QUARTZDRV_PDEVICE *physDev, INT left, INT top, INT right, INT bottom,
		     INT xstart, INT ystart, INT xend, INT yend)
{
  FIXME("(%p, %d, %d, %d, %d, %d, %d, %d, %d): stub\n",
        physDev, left, top, right, bottom, xstart, ystart, xend, yend);
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_Ellipse
 */
BOOL QUARTZDRV_DC_Ellipse(QUARTZDRV_PDEVICE *physDev, INT left, INT top, INT right, INT bottom)
{
  FIXME("(%p, %d, %d, %d, %d): stub\n", physDev, left, top, right, bottom);
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_ExtFloodFill
 */
BOOL QUARTZDRV_DC_ExtFloodFill(QUARTZDRV_PDEVICE *physDev, INT x, INT y,
			    COLORREF color, UINT fillType)
{
  FIXME("(%p, %d, %d, 0x%08lx, %u): stub\n", physDev, x, y, color, fillType);
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_GetPixel
 */
COLORREF QUARTZDRV_DC_GetPixel(QUARTZDRV_PDEVICE *physDev, INT x, INT y)
{
  FIXME("(%p, %d, %d): stub\n", physDev, x, y);
  return RGB(0,0,0); /* FIXME: Always returns black */
}

/***********************************************************************
 *		QUARTZDRV_DC_LineTo
 */
BOOL QUARTZDRV_DC_LineTo(QUARTZDRV_PDEVICE *physDev, INT x, INT y)
{
  FIXME("(%x, %d, %d): stub\n", physDev, x, y);

  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_PaintRgn
 */
BOOL QUARTZDRV_DC_PaintRgn(QUARTZDRV_PDEVICE *physDev, HRGN hrgn)
{
  FIXME("(%p, %p): stub\n", physDev, hrgn);
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_Pie
 */
BOOL QUARTZDRV_DC_Pie(QUARTZDRV_PDEVICE *physDev, INT left, INT top, INT right, INT bottom,
		   INT xstart, INT ystart, INT xend, INT yend)
{
  FIXME("(%p, %d, %d, %d, %d, %d, %d, %d, %d): stub\n",
	physDev, left, top, right, bottom, xstart, ystart, xend, yend);
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_Polygon
 */
BOOL QUARTZDRV_DC_Polygon(QUARTZDRV_PDEVICE *physDev, const POINT* pt, INT count)
{
  FIXME("(%p, %p, %d): stub\n", physDev, pt, count);
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_Polyline
 */
BOOL QUARTZDRV_DC_Polyline(QUARTZDRV_PDEVICE *physDev, const POINT* pt, INT count)
{
  FIXME("(%p, %p, %d): stub\n", physDev, pt, count);
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_PolyPolygon
 */
BOOL QUARTZDRV_DC_PolyPolygon(QUARTZDRV_PDEVICE *physDev, const POINT* pt, const INT* counts, UINT polygons)
{
  FIXME("(%p, %p, %p, %u): stub\n", physDev, pt, counts, polygons);
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_PolyPolyline
 */
BOOL QUARTZDRV_DC_PolyPolyline(QUARTZDRV_PDEVICE *physDev, const POINT* pt, const DWORD* counts, DWORD polylines)
{
  FIXME("(%p, %p, %p, %lu): stub\n", physDev, pt, counts, polylines);

  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_Rectangle
 */
BOOL QUARTZDRV_DC_Rectangle(QUARTZDRV_PDEVICE *physDev, INT left, INT top, INT right, INT bottom)
{
  FIXME("(%x, %d, %d, %d, %d): stub\n", physDev, left, top, right, bottom);

  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_RoundRect
 */
BOOL QUARTZDRV_DC_RoundRect(QUARTZDRV_PDEVICE *physDev, INT left, INT top, INT right,
			 INT bottom, INT ell_width, INT ell_height)
{
  FIXME("(%p, %d, %d, %d, %d, %d, %d): stub\n",
	physDev, left, top, right, bottom, ell_width, ell_height);

  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_SetPixel
 */
COLORREF QUARTZDRV_DC_SetPixel(QUARTZDRV_PDEVICE *physDev, INT x, INT y, COLORREF color)
{
  FIXME("(%x, %d, %d, 0x%08lx): stub\n", physDev, x, y, color);

  return RGB(0,0,0); /* FIXME: Always returns black */
}

/***********************************************************************
 *		QUARTZDRV_DC_BitBlt
 */
BOOL QUARTZDRV_DC_BitBlt(QUARTZDRV_PDEVICE *physDevDst, INT xDst, INT yDst,
		      INT width, INT height, QUARTZDRV_PDEVICE *physDevSrc,
		      INT xSrc, INT ySrc, DWORD rop)
{
  FIXME("(%p, %d, %d, %d, %d, %p, %d, %d, %lu): stub\n",
        physDevDst, xDst, yDst, width, height, physDevSrc, xSrc, ySrc, rop );
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_PatBlt
 */
BOOL QUARTZDRV_DC_PatBlt(QUARTZDRV_PDEVICE *physDev, INT left, INT top,
		      INT width, INT height, DWORD rop)
{
  FIXME("(%p, %d, %d, %d, %d, %lu): stub\n", physDev, left, top, width, height, rop );
  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_StretchBlt
 */
BOOL QUARTZDRV_DC_StretchBlt(QUARTZDRV_PDEVICE *physDevDst, INT xDst, INT yDst,
			  INT widthDst, INT heightDst,
			  QUARTZDRV_PDEVICE *physDevSrc, INT xSrc, INT ySrc,
			  INT widthSrc, INT heightSrc, DWORD rop)
{
  FIXME("(%p, %d, %d, %d, %d, %p, %d, %d, %d, %d, %lu): stub\n",
        physDevDst, xDst, yDst, widthDst, heightDst,
        physDevSrc, xSrc, ySrc, widthSrc, heightSrc, rop );

  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_ExtTextOut
 */
BOOL QUARTZDRV_DC_ExtTextOut(QUARTZDRV_PDEVICE *physDev, INT x, INT y, UINT flags,
			  const RECT *lpRect, LPCWSTR str, UINT count,
			  const INT *lpDx)
{
  FIXME("(%x, %d, %d, 0x%08x, %p, %s, %d, %p): stub\n",
        physDev, x, y, flags, lpRect, debugstr_wn(str,count), count, lpDx);

  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_GetCharWidth
 */
BOOL QUARTZDRV_DC_GetCharWidth(QUARTZDRV_PDEVICE *physDev, UINT firstChar, UINT lastChar,
			    LPINT buffer)
{
  UINT c;

  FIXME("(%p, %u, %u, %p): semistub\n", physDev, firstChar, lastChar, buffer);

  for(c=firstChar; c<=lastChar; c++) {
    buffer[c-firstChar] = physDev->cellWidth;
  }

  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_GetTextExtentPoint
 */
BOOL QUARTZDRV_DC_GetTextExtentPoint(QUARTZDRV_PDEVICE *physDev, LPCWSTR str, INT count,
				  LPSIZE size)
{
  FIXME(": stub\n");

  return TRUE;
}

/***********************************************************************
 *		QUARTZDRV_DC_GetTextMetrics
 */
BOOL QUARTZDRV_DC_GetTextMetrics(QUARTZDRV_PDEVICE *physDev, LPTEXTMETRICW lptm)
{
  FIXME(": stub\n");

  return TRUE;
}
