/*
 * QUARTZDRV initialization code
 *
 * Copyright 2000 Alexandre Julliard
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "config.h"

#include <stdarg.h>
#include <stdio.h>

#include "windef.h"
#include "winbase.h"
#include "wine/winbase16.h"
#include "wine/debug.h"
#include "quartzdrv.h"

WINE_DEFAULT_DEBUG_CHANNEL(quartzdrv);

extern void QUARTZDRV_process_attach(void);
extern void QUARTZDRV_process_detach(void);


/***********************************************************************
 *           QUARTZDRV initialisation routine
 */
BOOL WINAPI DllMain( HINSTANCE hinst, DWORD reason, LPVOID reserved )
{
    switch(reason)
    {
    case DLL_PROCESS_ATTACH:
        DisableThreadLibraryCalls(hinst);
        QUARTZDRV_process_attach();
        break;

    case DLL_PROCESS_DETACH:
        QUARTZDRV_process_detach();
        break;
    }
    return TRUE;
}

BOOL QUARTZDRV_GetEvent(void ** event);
void QUARTZDRV_ProcessEvent(void *event) {};

DWORD QUARTZDRV_MsgWaitForMultipleObjectsEx( DWORD count, const HANDLE *handles,
                                          DWORD timeout, DWORD mask, DWORD flags )
{
  void * event;
  if (QUARTZDRV_GetEvent(&event)) {
	QUARTZDRV_ProcessEvent(event);
	return WAIT_OBJECT_0 + count;
  }

  return WaitForMultipleObjectsEx(count, handles, flags & MWMO_WAITALL,
								  timeout, flags & MWMO_ALERTABLE);
}

void QUARTZDRV_QuitWindowsApp(void) {
  FIXME(": stub\n");
}
